<template>
  <div class="px-5">
    <v-row justify="center" class="mt-2 grey lighten-3 pa-12">
      <v-col cols="12" sm="8" class="white">
        <v-card class="card d-flex flex-wrap mx-3" color="primary" dark>
          <v-col class="text-center" cols="12">
            <span class="subtitle-1">
              LEAVE TYPE FORM
            </span>
          </v-col>
        </v-card>
        <v-form
          ref="form"
          v-model="valid"
          lazy-validation
        >
          <v-container class="py-0">
            <v-row justify="center">
              <v-col cols="12" md="7">
              <v-text-field
                  :counter="25"
                  :value="leavetype"
                  :rules="leaverule"
                  label="Leave Type"
                  @change="$emit('update:leavetype', $event)"
                ></v-text-field>
                <v-divider></v-divider>
              </v-col>
              <v-col cols="12" md="7">
                <v-text-field
                  :value="description"
                  :rules="descriptionrule"
                  label="Description"
                  @change="$emit('update:description', $event)"
                ></v-text-field>
                <v-divider></v-divider>
              </v-col>
              <v-col cols="12" md="7" class="mt-5 text-center">
                <v-btn
                  :disabled="!valid"
                  :loading="loading"
                  width="100"
                  color="secoundary"
                  class="ma-2 white--text"
                  v-on:click="validate"
                >
                  ADD
                </v-btn>
                <v-btn
                  color="warning"
                  class="ma-2"
                  v-on:click="cancel"
                >
                  Cancel
                </v-btn>
              </v-col>
            </v-row>
          </v-container>
        </v-form>
      </v-col>
    </v-row>
  </div>
</template>
<script>

export default {
  data() {
    return {
      valid: true,
      leaverule: [
        (v) => !!v || 'Type is required',
        (v) => (v && v.length <= 25) || 'Name must be less than 25 characters',
      ],
      descriptionrule: [
        (v) => !!v || 'Description is required',
        (v) => (v && v.length >= 5) || 'Descritpion must be greater than 5 characters',
      ],
    };
  },
  props: {
    leavetype: {
      type: String,
      required: true,
    },
    description: {
      type: String,
      required: true,
    },
    loading: {
      type: Boolean,
      required: false,
    },
  },
  methods: {
    validate() {
      if (this.$refs.form.validate()) {
        this.$emit('submit');
      }
    },
    cancel() {
      this.$emit('cancel');
    },
  },

};
</script>

<style scoped>
.card {
  top: -20px;
}
</style>
